package kr.co.vividnext.sodalive.admin.can

import kr.co.vividnext.sodalive.can.Can
import kr.co.vividnext.sodalive.can.CanStatus
import kr.co.vividnext.sodalive.extensions.moneyFormat

data class AdminCanRequest(
    val can: Int,
    val rewardCan: Int,
    val price: Int
) {
    fun toEntity(): Can {
        var title = "${can.moneyFormat()} 캔"
        if (rewardCan > 0) {
            title = "$title + ${rewardCan.moneyFormat()} 캔"
        }

        return Can(
            title = title,
            can = can,
            rewardCan = rewardCan,
            price = price,
            status = CanStatus.SALE
        )
    }
}
