package kr.co.vividnext.sodalive.aws.sqs

import com.amazonaws.services.sqs.AmazonSQS
import com.amazonaws.services.sqs.model.SendMessageRequest
import org.springframework.beans.factory.annotation.Value
import org.springframework.stereotype.Service

@Service
class SqsService(
    private val amazonSQS: AmazonSQS,

    @Value("\${cloud.aws.sqs.generate-coupon-url}")
    private val generateCouponQueueUrl: String
) {
    fun sendGenerateCouponMessage(message: String) {
        val request = SendMessageRequest()
            .withQueueUrl(generateCouponQueueUrl)
            .withMessageBody(message)

        amazonSQS.sendMessage(request)
    }
}
