package kr.co.vividnext.sodalive.marketing

import java.io.Serializable
import java.time.LocalDateTime
import javax.persistence.Embeddable
import javax.persistence.EmbeddedId
import javax.persistence.Entity
import javax.persistence.EnumType
import javax.persistence.Enumerated
import javax.persistence.PreUpdate

@Entity
data class AdTrackingHistory(
    @EmbeddedId
    val id: AdTrackingHistoryId,
    val mediaGroup: String,
    val pidName: String,
    val price: Double = 0.toDouble(),
    val locale: String? = null,
    var updatedAt: LocalDateTime = LocalDateTime.now()
) {
    @PreUpdate
    fun preUpdate() {
        updatedAt = LocalDateTime.now()
    }
}

@Embeddable
data class AdTrackingHistoryId(
    val pid: String,
    val memberId: Long,
    @Enumerated(value = EnumType.STRING)
    val type: AdTrackingHistoryType,
    val createdAt: LocalDateTime = LocalDateTime.now()
) : Serializable

enum class AdTrackingHistoryType {
    // 회원가입
    SIGNUP,

    // 첫결제
    FIRST_PAYMENT,

    // 재결제
    REPEAT_PAYMENT,

    // 자동로그인
    LOGIN
}
