package kr.co.vividnext.sodalive.member.auth

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.member.Member
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.OneToOne

@Entity
data class Auth(
    @Column(nullable = false)
    val name: String,
    @Column(nullable = false)
    val birth: String,
    @Column(columnDefinition = "TEXT", nullable = false)
    val uniqueCi: String,
    @Column(columnDefinition = "TEXT", nullable = false)
    val di: String,
    @Column(nullable = false)
    val gender: Int
) : BaseEntity() {
    @OneToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "member_id", nullable = false)
    var member: Member? = null
        set(value) {
            value?.auth = this
            field = value
        }
}
