package kr.co.vividnext.sodalive.member.auth

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.member.auth.QBlockAuth.blockAuth
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.stereotype.Repository

@Repository
interface BlockAuthRepository : JpaRepository<BlockAuth, Long>, BlockAuthQueryRepository

interface BlockAuthQueryRepository {
    fun findByUniqueCiAndDi(uniqueCi: String, di: String): Long?
}

@Repository
class BlockAuthQueryRepositoryImpl(private val queryFactory: JPAQueryFactory) : BlockAuthQueryRepository {
    override fun findByUniqueCiAndDi(uniqueCi: String, di: String): Long? {
        return queryFactory
            .select(blockAuth.id)
            .from(blockAuth)
            .where(
                blockAuth.uniqueCi.eq(uniqueCi)
                    .and(blockAuth.di.eq(di))
            )
            .fetchFirst()
    }
}
